/*
    Copyright (C) 2003 Fons Adriaensen <fons.adriaensen@skynet.be>
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include <clxclient.h>
#include <string.h>


int X_draw::textwidth (const char *str)
{
    int len, dx, dy;

    if (str == 0) return 0;
    len = strlen (str);
    if (len == 0) return 0;
 
    return XTextWidth (_font, str, len);
}


void X_draw::drawstring (const char *str)
{
    int len, dx, dy;

    if (str == 0) return;
    len = strlen (str);
    if (len == 0) return;
 
    dx = 0;
    if (_hsa != HLEFT) dx = -XTextWidth (_font, str, len);
    if (_hsa == HCENTER) dx /= 2;

    dy = 0;
    if      (_vsa == VTOP)  dy = _font->ascent;
    else if (_vsa == VCENTER) dy = (_font->ascent - _font->descent) / 2;
    else if (_vsa == VBOTTOM)  dy = -_font->descent;

    XDrawString (_dpy, _drw, _gct, _xx + dx,  _yy + dy, str, len);
}


void X_draw::drawlines (size_t n, int *x, int *y)
{
    size_t i, k, m;
    XPoint P [100], *p;

    m = (XMaxRequestSize (_dpy) - 3) / 2;
    if (m > 100) m = 100;

    while (n > 1)
    {
	if (n > m) k = m;
	else       k = n;

	for (i = 0, p = P; i < k; i++, p++) 
	{
	    p->x = *x++;
	    p->y = *y++;
	}
	--x;
	--y; 
	XDrawLines (_dpy, _drw, _gct, P, k, CoordModeOrigin);
	n -= k - 1;
    }
}

